unit LCatEGrp;

interface

uses
  LCatTool, LCatGAdd, LCatGChg, LCatGDel,
  WinTypes, WinProcs, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls, Menus, Dialogs;

type
  TDlgGrpList = class(TForm)
    Bevel1: TBevel;
    GrpList: TListBox;
    DlgGrpFont: TFontDialog;
    MainMenu: TMainMenu;
    MnuEdit: TMenuItem;
    MnuEditAdd: TMenuItem;
    MnuEditChg: TMenuItem;
    MnuEditDel: TMenuItem;
    MnuOptions: TMenuItem;
    MnuOptionsFont: TMenuItem;
    PopupMenu: TPopupMenu;
    PopAdd: TMenuItem;
    PopChange: TMenuItem;
    PopDelete: TMenuItem;
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    HelpBtn: TBitBtn;
    Toolbar: TPanel;
    BtnAdd: TSpeedButton;
    BtnChange: TSpeedButton;
    BtnDelete: TSpeedButton;
    BtnFont: TSpeedButton;
    procedure FormCreate(Sender: TObject);
    procedure MnuEditClick(Sender: TObject);
    procedure MnuEditAddClick(Sender: TObject);
    procedure MnuEditChgClick(Sender: TObject);
    procedure MnuEditDelClick(Sender: TObject);
    procedure MnuOptionsFontClick(Sender: TObject);
    procedure PopupMenuPopup(Sender: TObject);
    procedure DlgGrpFontApply(Sender: TObject; Wnd: Word);
  private
  public
    Changed : boolean;
    procedure AdjustButtons;
    procedure ApplyFont;
  end;

var
  DlgGrpList: TDlgGrpList;

implementation
Uses
  StfLib,
  LCatMain;

{$R *.DFM}

procedure TDlgGrpList.AdjustButtons;
begin
  BtnChange.Enabled:= GrpList.ItemIndex > -1;
  BtnDelete.Enabled:= GrpList.ItemIndex > -1;
end;

procedure TDlgGrpList.ApplyFont;
begin
  GrpList.Font := DlgGrpFont.Font;
end;

procedure TDlgGrpList.FormCreate(Sender: TObject);
begin
  GrpList.Font:= MainWnd.GrpLstFont;
end;

procedure TDlgGrpList.MnuEditClick(Sender: TObject);
begin
  MnuEditChg.Enabled:= GrpList.ItemIndex > -1;
  MnuEditDel.Enabled:= GrpList.ItemIndex > -1;
end;

procedure TDlgGrpList.MnuEditAddClick(Sender: TObject);
var i: integer;
begin with DlgGrpAdd, GrpList do begin
  TxtIdent.Text:= '';
  TxtDescr.Text:= '';
  ActiveControl:= TxtIdent;
  if (DlgGrpAdd.ShowModal = mrOK) and
     (StfRTS(TxtIdent.Text) <> '') then begin
    i:= Items.Add(SetGrpListItem(TxtIdent.Text,TxtDescr.Text));
    if  i > -1 then begin
      ItemIndex:= i;
      Changed:= true;
    end;
  end;
end; end;

procedure TDlgGrpList.MnuEditChgClick(Sender: TObject);
var i: integer;
begin with DlgGrpChg, GrpList do if ItemIndex > -1 then begin
  TxtIdent.Text:= GetGrpListIdent(Items[ItemIndex]);
  TxtDescr.Text:= GetGrpListDescr(Items[ItemIndex]);
  ActiveControl:= TxtDescr;
  if (DlgGrpChg.ShowModal = mrOK) and
     (StfRTS(TxtIdent.Text) <> '') then begin
    Items.Delete(ItemIndex);
    i:= Items.Add(SetGrpListItem(TxtIdent.Text,TxtDescr.Text));
    if i > -1 then GrpList.ItemIndex:= i;
    Changed:= true;
  end;
end; end;

procedure TDlgGrpList.MnuEditDelClick(Sender: TObject);
begin with DlgGrpDel, GrpList do if ItemIndex > -1 then begin
  TxtIdent.Caption:= GetGrpListIdent(Items[ItemIndex]);
  TxtDescr.Caption:= GetGrpListDescr(Items[ItemIndex]);
  ActiveControl:= OKBtn;
  if DlgGrpDel.ShowModal = mrOK then begin
    Items.Delete(ItemIndex);
    Changed:= true;
  end;
end; end;

procedure TDlgGrpList.MnuOptionsFontClick(Sender: TObject);
begin
  DlgGrpFont.Font:= GrpList.Font;
  if DlgGrpFont.Execute then
    ApplyFont;
end;

procedure TDlgGrpList.PopupMenuPopup(Sender: TObject);
begin
  PopChange.Enabled:= GrpList.ItemIndex > -1;
  PopDelete.Enabled:= GrpList.ItemIndex > -1;
end;

procedure TDlgGrpList.DlgGrpFontApply(Sender: TObject; Wnd: Word);
begin
  ApplyFont;
end;

end.

