unit Lcatemap;

interface

uses
  LCatTool, LCatMAdd, LCatMChg, LCatMDel,
  WinTypes, WinProcs, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls, Menus;

type
  TDlgMapList = class(TForm)
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    Bevel1: TBevel;
    MapList: TListBox;
    MainMenu: TMainMenu;
    MnuEdit: TMenuItem;
    MnuEditAdd: TMenuItem;
    MnuEditChg: TMenuItem;
    MnuEditDel: TMenuItem;
    PopupMenu: TPopupMenu;
    PopAdd: TMenuItem;
    PopChange: TMenuItem;
    PopDelete: TMenuItem;
    BitBtn1: TBitBtn;
    procedure MnuEditAddClick(Sender: TObject);
    procedure MnuEditChgClick(Sender: TObject);
    procedure MnuEditDelClick(Sender: TObject);
    procedure MnuEditClick(Sender: TObject);
    procedure PopupMenuPopup(Sender: TObject);
  private
  public
    Changed : boolean;
  end;

var
  DlgMapList: TDlgMapList;

implementation
Uses StfLib;

{$R *.DFM}

procedure TDlgMapList.MnuEditAddClick(Sender: TObject);
var i: integer;
begin with DlgMapAdd, MapList do begin
  TxtIdent.Text:= '';
  TxtDescr.Text:= '';
  ActiveControl:= TxtIdent;
  if (DlgMapAdd.ShowModal = mrOK) and
     (StfRTS(TxtIdent.Text) <> '') then begin
    i:= Items.Add(SetMapListItem(TxtIdent.Text,TxtDescr.Text));
    if  i > -1 then begin
      ItemIndex:= i;
      Changed:= true;
    end;
  end;
end; end;

procedure TDlgMapList.MnuEditChgClick(Sender: TObject);
var i: integer;
begin with DlgMapChg, MapList do if ItemIndex > -1 then begin
  TxtIdent.Text:= GetMapListIdent(Items[ItemIndex]);
  TxtDescr.Text:= GetMapListDescr(Items[ItemIndex]);
  ActiveControl:= TxtDescr;
  if (DlgMapChg.ShowModal = mrOK) and
     (StfRTS(TxtIdent.Text) <> '') then begin
    Items.Delete(ItemIndex);
    i:= Items.Add(SetMapListItem(TxtIdent.Text,TxtDescr.Text));
    if i > -1 then MapList.ItemIndex:= i;
    Changed:= true;
  end;
end; end;

procedure TDlgMapList.MnuEditDelClick(Sender: TObject);
begin with DlgMapDel, MapList do if ItemIndex > -1 then begin
  TxtIdent.Caption:= GetMapListIdent(Items[ItemIndex]);
  TxtDescr.Caption:= GetMapListDescr(Items[ItemIndex]);
  ActiveControl:= OKBtn;
  if DlgMapDel.ShowModal = mrOK then begin
    Items.Delete(ItemIndex);
    Changed:= true;
  end;
end; end;

procedure TDlgMapList.MnuEditClick(Sender: TObject);
begin
  MnuEditChg.Enabled:= MapList.ItemIndex > -1;
  MnuEditDel.Enabled:= MapList.ItemIndex > -1;
end;

procedure TDlgMapList.PopupMenuPopup(Sender: TObject);
begin
  PopChange.Enabled:= MapList.ItemIndex > -1;
  PopDelete.Enabled:= MapList.ItemIndex > -1;
end;

end.
