Unit LCatMain;

{$B-} { short-circuit boolean-expression evaluation }

interface

uses
  DefLib, StfLib, StpLib,
  LCatTool, LCatAbou, LCatEAdd, LCatEAdL, LCatEChg, LCatEChL,
  LCatEDel, LCatEDlL, LCatEGrp, LCatSFnm, LCatSFnL, LCatSGrp,
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Menus, StdCtrls, ExtCtrls, Buttons;

type
  TMainWnd = class(TForm)
    Toolbar: TPanel;
    DlgFont: TFontDialog;
    MainMenu: TMainMenu;
    MnuFile: TMenuItem;
    MnuFileNew: TMenuItem;
    MnuFileNewDos: TMenuItem;
    MnuFileNewLng: TMenuItem;
    MnuFileOpen: TMenuItem;
    MnuFileSaveAs: TMenuItem;
    MnuFileSave: TMenuItem;
    MnuFileSep1: TMenuItem;
    MnuFileExit: TMenuItem;
    MnuEdit: TMenuItem;
    MnuEditAdd: TMenuItem;
    MnuEditChange: TMenuItem;
    MnuEditDelete: TMenuItem;
    MnuEditSep1: TMenuItem;
    MnuEditGrpList: TMenuItem;
    MnuSearch: TMenuItem;
    MnuSearchFindFnm: TMenuItem;
    MnuSearchFindGrp: TMenuItem;
    MnuSearchFindAgain: TMenuItem;
    MnuOptions: TMenuItem;
    MnuOptionsGrpOrder: TMenuItem;
    MnuOptionsSep1: TMenuItem;
    MnuOptionsToolbar: TMenuItem;
    MnuOptionsHeader: TMenuItem;
    MnuOptionsStatusbar: TMenuItem;
    MnuOptionsHints: TMenuItem;
    MnuOptionsSavePos: TMenuItem;
    MnuOptionsFont: TMenuItem;
    MnuHelp: TMenuItem;
    MnuHelpIndex: TMenuItem;
    MnuHelpGeneral: TMenuItem;
    MnuHelpMainData: TMenuItem;
    MnuHelpGroupData: TMenuItem;
    MnuHelpSep1: TMenuItem;
    MnuHelpAbout: TMenuItem;
    BtnFileSave: TSpeedButton;
    BtnFileExit: TSpeedButton;
    BtnEditAdd: TSpeedButton;
    BtnEditChange: TSpeedButton;
    BtnEditDelete: TSpeedButton;
    BtnOptionsGrpOrder: TSpeedButton;
    BtnEditGrpList: TSpeedButton;
    BtnSearchFindFnm: TSpeedButton;
    BtnSearchFindGrp: TSpeedButton;
    BtnSearchFindAgain: TSpeedButton;
    BtnOptionsHints: TSpeedButton;
    BtnOptionsFont: TSpeedButton;
    BtnHelpInfo: TSpeedButton;
    PopMnListBox: TPopupMenu;
    PopAdd: TMenuItem;
    PopChange: TMenuItem;
    PopDelete: TMenuItem;
    PopGrpList: TMenuItem;
    PopGrpOrder: TMenuItem;
    PopFindFnm: TMenuItem;
    PopFindGrp: TMenuItem;
    PopFindAgain: TMenuItem;
    DlgFileOpen: TOpenDialog;
    DlgFileSave: TSaveDialog;
    StatusBar: TPanel;
    StatusTxt: TLabel;
    PnlListBox: TPanel;
    Header: TPanel;
    ListBox: TListBox;
    PopoMnuGrpOrder: TPopupMenu;
    PopHdrGrpOrder: TMenuItem;
    PopHdrFnmOrder: TMenuItem;
    procedure MnuFileNewDosClick(Sender: TObject);
    procedure MnuFileNewLngClick(Sender: TObject);
    procedure MnuFileOpenClick(Sender: TObject);
    procedure MnuFileSaveClick(Sender: TObject);
    procedure MnuFileSaveAsClick(Sender: TObject);
    procedure MnuFileExitClick(Sender: TObject);
    procedure MnuEditClick(Sender: TObject);
    procedure MnuEditAddClick(Sender: TObject);
    procedure MnuEditChangeClick(Sender: TObject);
    procedure MnuEditDeleteClick(Sender: TObject);
    procedure MnuEditGrpListClick(Sender: TObject);
    procedure MnuSearchClick(Sender: TObject);
    procedure MnuSearchFindFnmClick(Sender: TObject);
    procedure MnuSearchFindGrpClick(Sender: TObject);
    procedure MnuSearchFindAgainClick(Sender: TObject);
    procedure MnuOptionsGrpOrderClick(Sender: TObject);
    procedure MnuOptionsToolbarClick(Sender: TObject);
    procedure MnuOptionsHeaderClick(Sender: TObject);
    procedure MnuOptionsStatusbarClick(Sender: TObject);
    procedure MnuOptionsHintsClick(Sender: TObject);
    procedure MnuOptionsSavePosClick(Sender: TObject);
    procedure MnuOptionsFontClick(Sender: TObject);
    procedure MnuHelpClick(Sender: TObject);
    procedure MnuHelpAboutClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ListBoxDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure FormDestroy(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure PopMnListBoxPopup(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure PopHdrGrpOrderClick(Sender: TObject);
    procedure PopHdrFnmOrderClick(Sender: TObject);
    procedure PopoMnuGrpOrderPopup(Sender: TObject);
    procedure DlgFontApply(Sender: TObject; Wnd: Word);
  private
    function  MinHeight: integer;
    function  MinWidth: integer;
    procedure OnIdle(Sender: TObject; var Done: Boolean);
  public
    WndActive : boolean;
    Options   : T_Options;
    GrpList   : TStringList;
    FnmList   : TStringList;
    Changed   : boolean;
    LastFind  : T_LastFind;
    FindFnmIgn: boolean;
    FindFnmStr: String;
    FindGrpStr: String;
    GrpLstFont: TFont;
    procedure ApplyOptions;
    procedure ImportList;
    procedure ExportList;
    procedure ExportListTo(V_ToCatType: T_CatType);
    function  ReadGrpList(V_FileName: TFileName): boolean;
    function  SaveGrpList(V_FileName: TFileName): boolean;
    function  OKtoClose: boolean;
    procedure FileNew(V_CatType: T_CatType);
    function  FileOpen: boolean;
    function  FileSave: boolean;
    function  FileSaveAs: boolean;
    function  DoFileSave: boolean;
    procedure DoEditAddDos;
    procedure DoEditAddLng;
    procedure DoEditChangeDos;
    procedure DoEditChangeLng;
    procedure DoEditDeleteDos;
    procedure DoEditDeleteLng;
    procedure DoFindFnmDos;
    procedure DoFindFnmLng;
    procedure SetGrpOrder(V_GrpOrder: boolean);
    procedure FindAgainFnm;
    procedure FindAgainGrp;
    function  EnableChange: boolean;
    function  EnableDelete: boolean;
    function  EnableFind: boolean;
    function  EnableFindAgain: boolean;
    procedure AdjustToolbar;
    procedure WMGetMinMaxInfo(var V_Msg: Tmessage); message WM_GetMinMaxInfo;
    procedure ApplyFont;
  end;

var
  MainWnd: TMainWnd;

implementation

{$R *.DFM}

function  TMainWnd.MinHeight: integer;
begin with Options do begin
  Result:= 48 + ListBox.ItemHeight
    + Toolbar.Height   * ord(OptToolbar)
    + Header.Height    * ord(OptHeader)
    + Statusbar.Height * ord(OptStatusbar);
end end;

function  TMainWnd.MinWidth: integer;
begin Result:= BtnHelpInfo.Left + BtnHelpInfo.Width + 15; end;

procedure TMainWnd.WMGetMinMaxInfo(var V_Msg: Tmessage);
begin
  if WndActive then
    with PMinMaxInfo(V_Msg.lparam)^.ptMinTrackSize do begin
      x:= MinWidth;
      y:= MinHeight;
    end;
end;

procedure TMainWnd.OnIdle(Sender: TObject; var Done: Boolean);
begin
  if DlgGrpList.Visible then
    DlgGrpList.AdjustButtons;
end;

procedure TMainWnd.MnuFileNewDosClick(Sender: TObject);
begin FileNew(ct_DosNames); end;

procedure TMainWnd.MnuFileNewLngClick(Sender: TObject);
begin FileNew(ct_LongNames); end;

procedure TMainWnd.MnuFileOpenClick(Sender: TObject);
begin if OkToClose then with Options, DlgFileOpen do begin
  FileName:= DataFile;
  if DlgFileOpen.Execute then begin
    DataFile:= FileName;
    if CompareText(ExtractFileExt(FileName),C_LngFileExt) = 0 then
      SetCatType(ct_LongNames)
    else
      SetCatType(ct_DosNames);
    FileOpen;
    AdjustToolbar;
  end;
end end;

procedure TMainWnd.MnuFileSaveClick(Sender: TObject);
begin FileSave; AdjustToolbar; end;

procedure TMainWnd.MnuFileSaveAsClick(Sender: TObject);
begin FileSaveAs; AdjustToolbar; end;

procedure TMainWnd.MnuFileExitClick(Sender: TObject);
begin Close; end;

procedure TMainWnd.MnuEditClick(Sender: TObject);
begin
  MnuEditChange.Enabled := EnableChange;
  MnuEditDelete.Enabled := EnableDelete;
end;

procedure TMainWnd.MnuEditAddClick(Sender: TObject);
begin case Options.OptCatType of
  ct_DosNames : DoEditAddDos;
  ct_LongNames: DoEditAddLng;
end end;

procedure TMainWnd.MnuEditChangeClick(Sender: TObject);
begin case Options.OptCatType of
  ct_DosNames : DoEditChangeDos;
  ct_LongNames: DoEditChangeLng;
end end;

procedure TMainWnd.MnuEditDeleteClick(Sender: TObject);
begin case Options.OptCatType of
  ct_DosNames : DoEditDeleteDos;
  ct_LongNames: DoEditDeleteLng;
end end;

procedure TMainWnd.MnuEditGrpListClick(Sender: TObject);
begin
  DlgGrpList.GrpList.Items.Clear;
  DlgGrpList.GrpList.Items.Assign(GrpList);
  DlgGrpList.Changed:= false;
  DlgGrpList.ShowHint:= Options.OptHints;
  if (DlgGrpList.ShowModal = mrOK) and DlgGrpList.Changed then begin
    GrpList.Clear;
    GrpList.Assign(DlgGrpList.GrpList.Items);
    DlgGrpList.GrpList.Items.Clear;
    Changed:= true;
    ListBox.Refresh;
    AdjustToolbar;
  end;
end;

procedure TMainWnd.MnuSearchClick(Sender: TObject);
begin
  MnuSearchFindFnm.Enabled   := EnableFind;
  MnuSearchFindGrp.Enabled   := EnableFind;
  MnuSearchFindAgain.Enabled := EnableFindAgain;
end;

procedure TMainWnd.MnuSearchFindFnmClick(Sender: TObject);
begin case Options.OptCatType of
  ct_DosNames : DoFindFnmDos;
  ct_LongNames: DoFindFnmLng;
end end;

procedure TMainWnd.MnuSearchFindGrpClick(Sender: TObject);
var i: integer; ok: boolean;
begin if ListBox.Items.Count > 0 then with DlgFindGrp do begin
  TxtGrp.Items:= GrpList;
  TxtGrp.ItemIndex:= GrpList.IndexOf(FullGrpStr(FindGrpStr,GrpList));
  if TxtGrp.ItemIndex = -1 then TxtGrp.Text:= FindGrpStr;
  ActiveControl:= TxtGrp;
  if DlgFindGrp.ShowModal = mrOK then begin
    FindGrpStr:= StfUpp(StfSub(StfRTS(TxtGrp.Text),1,GV_GrpLen));
    LastFind:= lf_Grp;
    if FindGrpStr <> '' then with ListBox do begin
      i:= -1; ok:= false;
      while (not ok) and (i < Items.Count - 1) do begin
        Inc(i);
        if Options.OptGrpOrder then
          ok:= GetListGrp(Items[i]) >= FindGrpStr
        else
          ok:= StpPos(GetListGrp(Items[i]),FindGrpStr) = 1;
      end;
      if ok then ItemIndex:= i
      else MessageDlg(GV_ProgIdn+
        ': No groups matching'#13'"'+FindGrpStr+'"',
        mtInformation,[mbOk],0);
    end;
  end;
  AdjustToolbar;
end; end;

procedure TMainWnd.MnuSearchFindAgainClick(Sender: TObject);
begin case LastFind of
  lf_Unknown : ;
  lf_Fnm     : FindAgainFnm;
  lf_Grp     : FindAgainGrp;
end end;

procedure TMainWnd.FindAgainFnm;
var i: integer; ok: boolean; s: String;
begin
  if (ListBox.Items.Count > 0) and (FindFnmStr <> '')
  then with ListBox do begin
    if Options.OptCatType = ct_DosNames then
      s:= StfSub(FindFnmStr,1,GV_FnmLen)
    else
      s:= FindFnmStr;
    i:= ItemIndex; ok:= false;
    while (not ok) and (i < Items.Count - 1) do begin
      Inc(i);
      if (Options.OptCatType = ct_DosNames) or FindFnmIgn then
        ok:= StpUppPos(GetListFnm(Items[i]),s) = 1
      else
        ok:= StpPos(GetListFnm(Items[i]),s) = 1;
    end;
    if ok then ItemIndex:= i
    else MessageDlg(GV_ProgIdn+
      ': No files matching'#13'"'+s+'"'#13'after current row',
      mtInformation,[mbOk],0);
    AdjustToolbar;
  end;
end;

procedure TMainWnd.FindAgainGrp;
var i: integer; ok: boolean;
begin
  if (ListBox.Items.Count > 0) and (FindGrpStr <> '')
  then with ListBox do begin
    i:= ItemIndex; ok:= false;
    while (not ok) and (i < Items.Count - 1) do begin
      Inc(i); ok:= StpPos(GetListGrp(Items[i]),FindGrpStr) = 1;
    end;
    if ok then ItemIndex:= i
    else MessageDlg(GV_ProgIdn+
      ': No groups matching'#13'"'+FindGrpStr+'"'#13'after current row',
      mtInformation,[mbOk],0);
    AdjustToolbar;
  end;
end;

procedure TMainWnd.MnuOptionsGrpOrderClick(Sender: TObject);
begin
  SetGrpOrder(not options.OptGrpOrder);
  Listbox.SetFocus;
end;

procedure TMainWnd.MnuOptionsToolbarClick(Sender: TObject);
begin with Options do begin
  OptToolbar:= not OptToolbar;
  ApplyOptions;
end; end;

procedure TMainWnd.MnuOptionsHeaderClick(Sender: TObject);
begin with Options do begin
  OptHeader:= not OptHeader;
  ApplyOptions;
end; end;

procedure TMainWnd.MnuOptionsStatusbarClick(Sender: TObject);
begin with Options do begin
  OptStatusbar:= not OptStatusbar;
  ApplyOptions;
end; end;

procedure TMainWnd.MnuOptionsHintsClick(Sender: TObject);
begin with Options do begin
  OptHints:= not OptHints;
  ApplyOptions;
end; end;

procedure TMainWnd.MnuOptionsSavePosClick(Sender: TObject);
begin with Options do begin
  OptSavePos:= not OptSavePos;
  ApplyOptions;
end; end;

procedure TMainWnd.MnuOptionsFontClick(Sender: TObject);
begin
  DlgFont.Font:= ListBox.Font;
  if DlgFont.Execute then ApplyFont;
end;

procedure TMainWnd.MnuHelpClick(Sender: TObject);
begin
  Screen.Cursor:= crHourGlass;
  if      Sender = MnuHelpGeneral then
    Application.HelpCommand(HELP_CONTEXT,HC_General)
  else if Sender = MnuHelpMainData then
    Application.HelpCommand(HELP_CONTEXT,HC_MainData)
  else if Sender = MnuHelpGroupData then
    Application.HelpCommand(HELP_CONTEXT,HC_GroupData)
  else
    Application.HelpCommand(HELP_CONTENTS, 0);
  Screen.Cursor:= crDefault;
end;

procedure TMainWnd.MnuHelpAboutClick(Sender: TObject);
begin AboutBox.ShowModal; end;

procedure TMainWnd.FormCreate(Sender: TObject);
begin
  GV_ProgIdn    :=
    StfUpp(StfBefore(ExtractFileName(Application.ExeName),'.'));
  GV_SettingFnm := (ChangeFileExt(Application.ExeName,C_IniFileExt));
  GrpList:= TStringList.Create; GrpList.Sorted:= true;
  FnmList:= TStringList.Create; FnmList.Sorted:= true;
  GrpLstFont:= TFont.Create;
  Options   := C_DflOptions;
  if ReadOptions(Options) then with Options do begin
    Top    := WndTop;
    Left   := WndLeft;
    Height := WndHeight;
    Width  := WndWidth;
  end;
  DlgFileOpen.Filter:= C_FileFilter;
  DlgFileSave.Filter:= C_FileFilter;
  SetCatType(Options.OptCatType);
  Changed:= false;
  LastFind:= lf_Unknown;
  FindFnmStr:= '';
  FindGrpStr:= '';
  FindFnmIgn := true;
  FileOpen;
  Application.OnIdle:= OnIdle;
end;

procedure TMainWnd.ApplyOptions;
begin with Options do begin
  MainWnd.ShowHint           := OptHints;
  Header.Visible             := OptHeader;
  Toolbar.Visible            := OptToolbar;
  Statusbar.Visible          := OptStatusbar;
  MnuOptionsGrpOrder.Checked := OptGrpOrder;
  MnuOptionsToolbar.Checked  := OptToolbar;
  MnuOptionsHeader.Checked   := OptHeader;
  MnuOptionsStatusbar.Checked:= OptStatusbar;
  MnuOptionsHints.Checked    := OptHints;
  MnuOptionsSavePos.Checked  := OptSavePos;
  BtnOptionsHints.Down       := OptHints;
  StatusTxt.Caption          := StfLow(DataFile);
  ListBox.ItemHeight         := Abs(ListBox.Font.Height);
  Header.Height              := Round(Abs(Header.Font.Height)*1.4);
  SetGroupOrder(OptGrpOrder);
  AdjustToolbar;
  if Height < MinHeight then Height:= 0;
end; end;

function  TMainWnd.OKtoClose: boolean;
var ok: boolean;
begin
  ok:= true;
  if Changed then begin
    case MessageDlg(GV_ProgIdn+': Save changes?',
      mtConfirmation,mbYesNoCancel,0)
    of
      mrYes    : ok:= FileSave;
      mrNo     : ;
      mrCancel : ok:= false;
      else       ok:= false;
    end;
  end;
  OKtoClose:= ok;
end;

procedure TMainWnd.FileNew(V_CatType: T_CatType);
begin if OKtoClose then begin
  Options.DataFile:= '';
  GrpList.Clear;
  ListBox.Clear;
  Changed:= false;
  SetCatType(V_CatType);
  ApplyOptions;
end; end;

function  TMainWnd.FileOpen: boolean;
var ok: boolean;
begin
  ok:= false;
  if Options.DataFile <> '' then begin
    Screen.Cursor:= crHourGlass;
    ListBox.Visible:= false;
    try
      if not ReadGrpList(Options.DataFile) then GrpList.Clear;
      if Options.OptGrpOrder then begin
        FnmList.Clear;
        FnmList.LoadFromFile(Options.DataFile);
        ImportList;
        FnmList.Clear;
      end
      else begin
        ListBox.Clear;
        ListBox.Items.LoadFromFile(Options.DataFile);
      end;
      Changed:= false;
      ok:= true;
    finally
      ListBox.Visible:= true;
      Screen.Cursor:= crDefault;
    end;
  end;
  ApplyOptions;
  FileOpen:= ok;
end;

function  TMainWnd.FileSave: boolean;
begin
  if Options.DataFile = '' then Result:= FileSaveAs
                           else Result:= DoFileSave;
end;

function  TMainWnd.FileSaveAs: boolean;
var ok: boolean; NewType: T_CatType;
begin with Options, DlgFileSave do begin
  ok:= false;
  FileName:= DataFile;
  if DlgFileSave.Execute and (DataFile <> '') then begin
    ok:= true;
    DataFile:= FileName;
    if CompareText(ExtractFileExt(FileName),C_LngFileExt) = 0 then
      NewType:= ct_LongNames
    else
      NewType:= ct_DosNames;
    if NewType <> OptCatType then begin
      if NewType = ct_DosNames then
        ok:= MessageDlg('OK to truncate filename?',
                         mtConfirmation, mbOkCancel, 0) = mrOK;
      if ok then begin
        ExportListTo(NewType);
        SetCatType(NewType);
        ImportList;
        FnmList.Clear;
      end;
    end;
    if ok then begin
      ApplyOptions;
      ok:= DoFileSave;
    end;
  end;
  Result:= ok;
end end;

function  TMainWnd.DoFileSave: boolean;
var ok: boolean;
begin
  ok:= false;
  if Options.DataFile <> '' then begin
    Screen.Cursor:= crHourGlass;
    try
      SaveGrpList(Options.DataFile);
      if Options.OptGrpOrder then begin
        ExportList;
        FnmList.SaveToFile(Options.DataFile);
        FnmList.Clear;
      end
      else
        ListBox.Items.SaveToFile(Options.DataFile);
      Changed:= false;
      ok:= true;
    finally
      Screen.Cursor:= crDefault;
    end;
  end;
  if not ok then MessageDlg(GV_ProgIdn+
    ': Unable to save file'#13+Options.DataFile,
    mtError,[mbOK],0);
  DoFileSave:= ok;
end;

procedure TMainWnd.DoEditAddDos;
var NewEntry: StpTyp; i: integer;
  function DialogOk: boolean;
   var rc: integer;
   begin with DlgAdd do begin
    repeat
      rc:= DlgAdd.ShowModal;
      NewEntry:= SetListItem(StfRLS(TxtFnm.Text),StfRLS(TxtExt.Text),
        GetGrpListIdent(StfUpp(StfRLS(TxtGrp.Text))));
    until (rc <> mrOK) or not (
          ErrMsg((StfRLS(TxtFnm.Text)='') or (StfRLS(TxtGrp.Text)=''),
                'Need non-empty Name and Group fields')
       or ErrMsg(ListBox.Items.IndexOf(NewEntry) > -1,
                'Cannot add:'#13+
                '"'+NewEntry+'"'#13+
                'Entry already exists.')
      );
    DialogOk:= rc = mrOK;
   end; end;
begin with DlgAdd, ListBox, Items do begin
  TxtFnm.Text := '';
  TxtExt.Text := '';
  TxtGrp.Items:= GrpList;
  TxtGrp.ItemIndex:= -1;
  ActiveControl:= TxtFnm;
  if DialogOK then begin
    i:= Items.Add(NewEntry);
    if i > -1 then ItemIndex:= i;
    Changed:= true;
    AdjustToolbar;
  end;
end; end;

procedure TMainWnd.DoEditAddLng;
var NewEntry: StpTyp; i: integer;
  function DialogOk: boolean;
   var rc: integer;
   begin with DlgAddLng do begin
    repeat
      rc:= DlgAddLng.ShowModal;
      NewEntry:= SetListItem(StfRLS(TxtFnm.Text),StfRLS(TxtExt.Text),
        GetGrpListIdent(StfUpp(StfRLS(TxtGrp.Text))));
    until (rc <> mrOK) or not (
          ErrMsg((StfRLS(TxtFnm.Text)='') or (StfRLS(TxtGrp.Text)=''),
                'Need non-empty Name and Group fields')
       or ErrMsg(ListBox.Items.IndexOf(NewEntry) > -1,
                'Cannot add:'#13+
                '"'+NewEntry+'"'#13+
                'Entry already exists.')
      );
    DialogOk:= rc = mrOK;
   end; end;
begin with DlgAddLng, ListBox, Items do begin
  TxtFnm.Text := '';
  TxtExt.Text := '';
  TxtGrp.Items:= GrpList;
  TxtGrp.ItemIndex:= -1;
  ActiveControl:= TxtFnm;
  if DialogOK then begin
    i:= Items.Add(NewEntry);
    if i > -1 then ItemIndex:= i;
    Changed:= true;
    AdjustToolbar;
  end;
end; end;

procedure TMainWnd.DoEditChangeDos;
var OldEntry, NewEntry: StpTyp; i: integer;
  function DialogOk: boolean;
   var rc: integer;
   begin with DlgChange do begin
    repeat
      rc:= DlgChange.ShowModal;
      NewEntry:= SetListItem(StfRLS(TxtFnm.Text),StfRLS(TxtExt.Text),
        GetGrpListIdent(StfUpp(StfRLS(TxtGrp.Text))));
    until (rc <> mrOK) or (newEntry = OldEntry) or not (
          ErrMsg((StfRLS(TxtFnm.Text)='') or (StfRLS(TxtGrp.Text)=''),
                'Need non-empty Name and Group fields')
       or ErrMsg(ListBox.Items.IndexOf(NewEntry) > -1,
                'Cannot change to:'#13+
                '"'+NewEntry+'"'#13+
                'Entry already exists.')
      );
    DialogOk:= rc = mrOK;
   end; end;
begin with DlgChange, ListBox, Items do if ItemIndex > -1 then begin
  OldEntry:= Items[ItemIndex];
  TxtFnm.Text := GetListFnm(Items[ItemIndex]);
  TxtExt.Text := GetListExt(Items[ItemIndex]);
  TxtGrp.Items:= GrpList;
  TxtGrp.ItemIndex:=
    GrpList.IndexOf(FullGrpStr(GetListGrp(Items[ItemIndex]),GrpList));
  if TxtGrp.ItemIndex = -1 then
    TxtGrp.Text := FullGrpStr(GetListGrp(Items[ItemIndex]),GrpList);
  ActiveControl:= TxtFnm;
  if DialogOk and (NewEntry <> OldEntry) then begin
    Items.Delete(ItemIndex);
    i:= Items.Add(NewEntry);
    if i > -1 then ItemIndex:= i;
    Changed:= true;
    AdjustToolbar;
  end;
end; end;

procedure TMainWnd.DoEditChangeLng;
var OldEntry, NewEntry: StpTyp; i: integer;
  function DialogOk: boolean;
   var rc: integer;
   begin with DlgChangeLng do begin
    repeat
      rc:= DlgChangeLng.ShowModal;
      NewEntry:= SetListItem(StfRLS(TxtFnm.Text),StfRLS(TxtExt.Text),
        GetGrpListIdent(StfUpp(StfRLS(TxtGrp.Text))));
    until (rc <> mrOK) or (newEntry = OldEntry) or not (
          ErrMsg((StfRLS(TxtFnm.Text)='') or (StfRLS(TxtGrp.Text)=''),
                'Need non-empty Name and Group fields')
       or ErrMsg(ListBox.Items.IndexOf(NewEntry) > -1,
                'Cannot change to:'#13+
                '"'+NewEntry+'"'#13+
                'Entry already exists.')
      );
    DialogOk:= rc = mrOK;
   end; end;
begin with DlgChangeLng, ListBox, Items do if ItemIndex > -1 then begin
  OldEntry:= Items[ItemIndex];
  TxtFnm.Text := GetListFnm(Items[ItemIndex]);
  TxtExt.Text := GetListExt(Items[ItemIndex]);
  TxtGrp.Items:= GrpList;
  TxtGrp.ItemIndex:=
    GrpList.IndexOf(FullGrpStr(GetListGrp(Items[ItemIndex]),GrpList));
  if TxtGrp.ItemIndex = -1 then
    TxtGrp.Text := FullGrpStr(GetListGrp(Items[ItemIndex]),GrpList);
  ActiveControl:= TxtFnm;
  if DialogOk and (NewEntry <> OldEntry) then begin
    Items.Delete(ItemIndex);
    i:= Items.Add(NewEntry);
    if i > -1 then ItemIndex:= i;
    Changed:= true;
    AdjustToolbar;
  end;
end; end;

procedure TMainWnd.DoEditDeleteDos;
begin with DlgDelete, ListBox, Items do if ItemIndex > -1 then begin
  TxtFnm.Caption := GetListFnm(Items[ItemIndex]);
  TxtExt.Caption := GetListExt(Items[ItemIndex]);
  TxtGrp.Caption := FullGrpStr(GetListGrp(Items[ItemIndex]),GrpList);
  if DlgDelete.ShowModal = mrOK then begin
    Items.Delete(ItemIndex);
    Changed:= true;
    AdjustToolbar;
  end;
end; end;

procedure TMainWnd.DoEditDeleteLng;
begin with DlgDeleteLng, ListBox, Items do if ItemIndex > -1 then begin
  TxtFnm.Caption := GetListFnm(Items[ItemIndex]);
  TxtExt.Caption := GetListExt(Items[ItemIndex]);
  TxtGrp.Caption := FullGrpStr(GetListGrp(Items[ItemIndex]),GrpList);
  if DlgDeleteLng.ShowModal = mrOK then begin
    Items.Delete(ItemIndex);
    Changed:= true;
    AdjustToolbar;
  end;
end; end;

procedure TMainWnd.DoFindFnmDos;
var i: integer; ok: boolean;
begin if ListBox.Items.Count > 0 then with DlgFindFnm do begin
  TxtFnm.Text:= StfSub(FindFnmStr,1,GV_FnmLen);
  ActiveControl:= TxtFnm;
  if DlgFindFnm.ShowModal = mrOK then begin
    FindFnmStr:= StfRTS(TxtFnm.Text);
    LastFind:= lf_Fnm;
    if FindFnmStr <> '' then with ListBox do begin
      i:= -1; ok:= false;
      while (not ok) and (i < Items.Count - 1) do begin
        Inc(i);
        if Options.OptGrpOrder then
          ok:= StpUppPos(GetListFnm(Items[i]),FindFnmStr) = 1
        else
          ok:= StpUppCmp(GetListFnm(Items[i]),FindFnmStr) >= 0;
      end;
      if ok then ItemIndex:= i
      else MessageDlg(GV_ProgIdn+
        ': No files matching'#13'"'+FindFnmStr+'"',
        mtInformation,[mbOk],0);
    end;
  end;
  AdjustToolbar;
end; end;

procedure TMainWnd.DoFindFnmLng;
var i: integer; ok: boolean;
begin if ListBox.Items.Count > 0 then with DlgFindFnmLng do begin
  TxtFnm.Text:= StfSub(FindFnmStr,1,GV_FnmLen);
  ActiveControl:= TxtFnm;
  ChkIgnore.Checked := FindFnmIgn;
  if DlgFindFnmLng.ShowModal = mrOK then begin
    FindFnmStr:= StfRTS(TxtFnm.Text);
    LastFind:= lf_Fnm;
    FindFnmIgn:= ChkIgnore.Checked;
    if FindFnmStr <> '' then with ListBox do begin
      i:= -1; ok:= false;
      while (not ok) and (i < Items.Count - 1) do begin
        Inc(i);
        if FindFnmIgn then begin
          if Options.OptGrpOrder then
            ok:= StpUppPos(GetListFnm(Items[i]),FindFnmStr) = 1
          else
            ok:= StpUppCmp(GetListFnm(Items[i]),FindFnmStr) >= 0;
        end
        else begin
          if Options.OptGrpOrder then
            ok:= StpPos(GetListFnm(Items[i]),FindFnmStr) = 1
          else
            ok:= GetListFnm(Items[i]) >= FindFnmStr;
        end;
      end;
      if ok then ItemIndex:= i
      else MessageDlg(GV_ProgIdn+
        ': No files matching'#13'"'+FindFnmStr+'"',
        mtInformation,[mbOk],0);
    end;
  end;
  AdjustToolbar;
end; end;

procedure TMainWnd.SetGrpOrder(V_GrpOrder: boolean);
var CurrentEntry: StpTyp;
begin with Options, ListBox do begin
  Screen.Cursor:= crHourglass;
  ListBox.Visible:= false;
  try
    if (Items.Count=0) or (ItemIndex<0) then CurrentEntry:= ''
    else if OptGrpOrder then CurrentEntry:= ToOrdFnm(Items[ItemIndex])
    else CurrentEntry:= ToOrdGrp(Items[ItemIndex]);
    ExportList;
    OptGrpOrder:= V_GrpOrder;
    ApplyOptions;
    ImportList;
    FnmList.Clear;
    if CurrentEntry = '' then ItemIndex:= -1
    else ItemIndex:= Items.IndexOf(CurrentEntry);
  finally
    ListBox.Visible:= true;
    Screen.Cursor:= crDefault;
  end;
end end;

procedure TMainWnd.ImportList;
var i: integer;
begin with ListBox, Options do begin
  ListBox.Clear;
  for i:= 0 to FnmList.Count-1 do
    if OptGrpOrder then Items.Add(ToOrdGrp(FnmList[i]))
                   else Items.Add(FnmList[i]);
end end;
procedure TMainWnd.ExportList;
var i: integer;
begin with ListBox, Options do begin
  FnmList.Clear;
  for i:= 0 to Items.Count-1 do
    if OptGrpOrder then FnmList.Add(ToOrdFnm(Items[i]))
                   else FnmList.Add(Items[i]);
end end;

procedure TMainWnd.ExportListTo(V_ToCatType: T_CatType);
var i: integer;
begin with ListBox, Options do begin
  FnmList.Clear;
  for i:= 0 to Items.Count-1 do
    if OptGrpOrder then FnmList.Add(ToCatType(V_ToCatType,ToOrdFnm(Items[i])))
                   else FnmList.Add(ToCatType(V_ToCatType,Items[i]));
end end;

function TMainWnd.ReadGrpList(V_FileName: TFileName): boolean;
var ok: boolean; GrpFnm: TFileName;
begin
  ok:= false;
  GrpFnm:= ChangeFileExt(V_FileName,C_GrpFileExt);
  if FileExists(GrpFnm) then begin
    GrpList.Clear;
    GrpList.LoadFromFile(GrpFnm);
    ok:= true;
  end;
  ReadGrpList:= ok;
end;

function TMainWnd.SaveGrpList(V_FileName: TFileName): boolean;
var ok: boolean; GrpFnm: TFileName;
begin
  ok:= false;
  try
    GrpFnm:= ChangeFileExt(V_FileName,C_GrpFileExt);
    GrpList.SaveToFile(GrpFnm);
    ok:= true;
  finally
    SaveGrpList:= ok;
  end;
end;

procedure TMainWnd.ListBoxDrawItem(Control: TWinControl; Index: Integer;
  Rect: TRect; State: TOwnerDrawState);
begin with (Control as TListBox),Canvas do begin
  FillRect(Rect);
  TextOut(Rect.Left, Rect.Top, Items[Index] + ' ' +
    GetGrpListDescr(FullGrpStr(GetListGrp(Items[Index]),GrpList)));
  AdjustToolbar;
end; end;

procedure TMainWnd.FormDestroy(Sender: TObject);
begin
  try
    GrpList.Free;
    FnmList.Free;
    GrpLstFont.Free;
  finally
    Application.HelpCommand(HELP_QUIT, 0);
  end;
end;

procedure TMainWnd.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin CanClose:= OKtoClose end;

procedure TMainWnd.PopMnListBoxPopup(Sender: TObject);
begin
  PopChange.Enabled    := EnableChange;
  PopDelete.Enabled    := EnableDelete;
  PopFindFnm.Enabled   := EnableFind;
  PopFindGrp.Enabled   := EnableFind;
  PopFindAgain.Enabled := EnableFindAgain;
  PopGrporder.Checked  := Options.OptGrpOrder;
end;

procedure TMainWnd.AdjustToolbar;
begin if Options.OptToolbar then begin
  BtnEditChange.Enabled      := EnableChange;
  BtnEditDelete.Enabled      := EnableDelete;
  BtnSearchFindFnm.Enabled   := EnableFind;
  BtnSearchFindGrp.Enabled   := EnableFind;
  BtnSearchFindAgain.Enabled := EnableFindAgain;
  BtnOptionsGrpOrder.Down    := Options.OptGrpOrder;
end end;

function TMainWnd.EnableChange: boolean;
begin EnableChange:= ListBox.ItemIndex > -1; end;

function TMainWnd.EnableDelete: boolean;
begin EnableDelete:= ListBox.ItemIndex > -1; end;

function TMainWnd.EnableFind: boolean;
begin EnableFind:= ListBox.Items.Count > 0; end;

function TMainWnd.EnableFindAgain: boolean;
begin case LastFind of
  lf_Fnm : Result:= EnableFind and (FindFnmStr <> '');
  lf_Grp : Result:= EnableFind and (FindGrpStr <> '');
  else     Result:= false;
end; end;

procedure TMainWnd.FormShow(Sender: TObject);
begin WndActive:= true; end;

procedure TMainWnd.FormClose(Sender: TObject; var Action: TCloseAction);
begin WriteOptions(Options) end;

procedure TMainWnd.ApplyFont;
begin
  ListBox.Font := DlgFont.Font;
  Header.Font  := DlgFont.Font;
  ApplyOptions;
end;

procedure TMainWnd.PopHdrGrpOrderClick(Sender: TObject);
begin
  SetGrpOrder(true);
  ListBox.SetFocus;
end;

procedure TMainWnd.PopHdrFnmOrderClick(Sender: TObject);
begin
  SetGrpOrder(false);
  ListBox.SetFocus;
end;

procedure TMainWnd.PopoMnuGrpOrderPopup(Sender: TObject);
begin
  PopHdrGrpOrder.Checked:= Options.OptGrpOrder;
  PopHdrFnmOrder.Checked:= not Options.OptGrpOrder;
  ListBox.SetFocus;
end;

procedure TMainWnd.DlgFontApply(Sender: TObject; Wnd: Word);
begin
  ApplyFont;
end;

end.
